"use strict";
exports.__esModule = true;
exports.createClient = void 0;
var axios_1 = require("axios");
var config_json_1 = require("../config.json");
var oauth2_manager_1 = require("./oauth2-manager");
var createClient = function () {
    var client = axios_1["default"].create({
        baseURL: config_json_1.API_URL
    });
    client.interceptors.request.use(function (config) {
        var user = oauth2_manager_1.getCurrentUser();
        if (user !== null) {
            config.headers = {
                'X-AUTH-TOKEN': "" + user.accessToken
            };
        }
        return config;
    });
    return client;
};
exports.createClient = createClient;
//# sourceMappingURL=api-client.js.map