"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
exports.__esModule = true;
exports.editKlink = exports.readKlink = exports.getCurrentUserKlinks = exports.createKlink = void 0;
var electron_log_1 = require("electron-log");
var api_client_1 = require("./api-client");
var client = api_client_1.createClient();
function createKlink(klinkDetails) {
    return __awaiter(this, void 0, void 0, function () {
        var result, data, e_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    electron_log_1["default"].info('[Klink] Creating klink');
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, 3, , 4]);
                    return [4 /*yield*/, client.post('/frontvault/v1/tokens', klinkDetails)];
                case 2:
                    result = _a.sent();
                    data = result.data;
                    return [2 /*return*/, data];
                case 3:
                    e_1 = _a.sent();
                    electron_log_1["default"].error("[Klink] Unable to create Klink: " + e_1.message);
                    throw new Error(e_1.message);
                case 4: return [2 /*return*/];
            }
        });
    });
}
exports.createKlink = createKlink;
function getCurrentUserKlinks(page) {
    return __awaiter(this, void 0, void 0, function () {
        var response, e_2;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    electron_log_1["default"].info('[Klink] Reading current user klinks');
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, 3, , 4]);
                    return [4 /*yield*/, client.get("/frontvault/v1/tokens?page=" + page)];
                case 2:
                    response = _a.sent();
                    return [2 /*return*/, response.data];
                case 3:
                    e_2 = _a.sent();
                    electron_log_1["default"].error("[Klink] Unable to read Klinks: " + e_2.message);
                    throw new Error('Unable to access Klink storage');
                case 4: return [2 /*return*/];
            }
        });
    });
}
exports.getCurrentUserKlinks = getCurrentUserKlinks;
function readKlink(klinkToken) {
    return __awaiter(this, void 0, void 0, function () {
        var data, token, title, sharedWith, notifications, url, e_3;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    electron_log_1["default"].info('[Klink] Reading klink');
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, 3, , 4]);
                    return [4 /*yield*/, client.get("/frontvault/v1/tokens/" + klinkToken)];
                case 2:
                    data = (_a.sent()).data;
                    token = data.token, title = data.title, sharedWith = data.sharedWith, notifications = data.notifications, url = data.url;
                    if (!data.is_read_only) {
                        return [2 /*return*/, {
                                editable: true,
                                token: token,
                                title: title,
                                sharedWith: sharedWith,
                                notifications: notifications,
                                data: data.data,
                                url: url
                            }];
                    }
                    return [2 /*return*/, {
                            editable: false,
                            token: token,
                            title: title,
                            data: data.data,
                            url: url
                        }];
                case 3:
                    e_3 = _a.sent();
                    if (e_3.response && e_3.response.status === 500) {
                        throw new Error('Klink not found');
                    }
                    electron_log_1["default"].error("[Klink] Unable to read Klink: " + e_3.message);
                    throw new Error('Unable to access Klink storage');
                case 4: return [2 /*return*/];
            }
        });
    });
}
exports.readKlink = readKlink;
function editKlink(token, klinkDetails) {
    return __awaiter(this, void 0, void 0, function () {
        var title, body, sharedWith, requestBody, response, data, e_4;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    electron_log_1["default"].info('[Klink] Modifying klink');
                    title = klinkDetails.title, body = klinkDetails.body, sharedWith = klinkDetails.sharedWith;
                    requestBody = {
                        title: title,
                        body: body,
                        sharedWith: sharedWith,
                        token: token
                    };
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, 3, , 4]);
                    return [4 /*yield*/, client.put('/frontvault/v1/tokens', requestBody)];
                case 2:
                    response = _a.sent();
                    data = response.data;
                    return [3 /*break*/, 4];
                case 3:
                    e_4 = _a.sent();
                    if (e_4.response && e_4.response.status === 403) {
                        throw new Error('No access to modify this klink, try logging in again');
                    }
                    electron_log_1["default"].error("[Klink] Unable to modify Klink: " + e_4.message);
                    throw new Error('Unable to access Klink storage');
                case 4: return [2 /*return*/];
            }
        });
    });
}
exports.editKlink = editKlink;
//# sourceMappingURL=api-klink-manager.js.map