"use strict";
// TODO: delete this file
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
exports.__esModule = true;
var axios_1 = require("axios");
var config_json_1 = require("../config.json");
var electron_log_1 = require("electron-log");
var jwt_decode_1 = require("jwt-decode");
var APP_SERVICE = 'kloke-app';
var AuthManager = /** @class */ (function () {
    function AuthManager() {
        this.currentUser = null;
        this.callbacks = [];
        this.client = axios_1["default"].create({
            baseURL: config_json_1.API_URL
        });
    }
    AuthManager.prototype.getCurrentUser = function () {
        return this.currentUser;
    };
    AuthManager.prototype.shouldRefresh = function () {
        if (this.currentUser === null) {
            return false;
        }
        var expirationDate = AuthManager.getJwtExpirationDate(this.currentUser.accessToken);
        return expirationDate !== null && expirationDate > new Date();
    };
    AuthManager.prototype.refresh = function () {
        return __awaiter(this, void 0, void 0, function () {
            var refreshToken, result, e_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        electron_log_1["default"].info('[Auth] Refreshing tokens');
                        return [4 /*yield*/, AuthManager.loadRefreshToken()];
                    case 1:
                        refreshToken = _a.sent();
                        if (!!refreshToken) return [3 /*break*/, 3];
                        return [4 /*yield*/, this.logout()];
                    case 2: return [2 /*return*/, _a.sent()];
                    case 3:
                        _a.trys.push([3, 6, , 8]);
                        return [4 /*yield*/, this.client.post('/v1/login/refresh', {
                                refreshToken: refreshToken
                            })];
                    case 4:
                        result = _a.sent();
                        return [4 /*yield*/, AuthManager.saveRefreshToken(result.data.refreshToken)];
                    case 5:
                        _a.sent();
                        this.currentUser = {
                            phone: result.data.phone,
                            accessToken: result.data.accessToken,
                            tfaMissing: result.data.tfaMissing
                        };
                        this.executeCallbacks();
                        return [3 /*break*/, 8];
                    case 6:
                        e_1 = _a.sent();
                        electron_log_1["default"].error("[Auth] Unable to refresh tokens: " + e_1.message);
                        return [4 /*yield*/, this.logout()];
                    case 7: return [2 /*return*/, _a.sent()];
                    case 8: return [2 /*return*/];
                }
            });
        });
    };
    AuthManager.prototype.login = function (phone, password) {
        return __awaiter(this, void 0, void 0, function () {
            var result, e_2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        electron_log_1["default"].info('[Auth] Logging in');
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 4, , 5]);
                        return [4 /*yield*/, this.client.post('/v1/login', {
                                phone: phone,
                                password: password
                            })];
                    case 2:
                        result = _a.sent();
                        return [4 /*yield*/, AuthManager.saveRefreshToken(result.data.refreshToken)];
                    case 3:
                        _a.sent();
                        this.currentUser = {
                            phone: result.data.phone,
                            accessToken: result.data.accessToken,
                            tfaMissing: result.data.tfaMissing
                        };
                        this.executeCallbacks();
                        return [2 /*return*/, AuthManager.generateAuthDetails(this.currentUser)];
                    case 4:
                        e_2 = _a.sent();
                        if (e_2.response && e_2.response.status === 401) {
                            throw new Error('Invalid credentials');
                        }
                        electron_log_1["default"].error("[Auth] Unable to login: " + e_2.message);
                        throw new Error('Unable to access Klink storage');
                    case 5: return [2 /*return*/];
                }
            });
        });
    };
    AuthManager.prototype.confirmTfa = function (code) {
        return __awaiter(this, void 0, void 0, function () {
            var result, e_3;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        electron_log_1["default"].info('[Auth] Confirming TFA');
                        if (this.currentUser === null) {
                            throw new Error('[DEV] User must be logged before confirming TFA');
                        }
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 4, , 5]);
                        return [4 /*yield*/, this.client.post('/v1/login/tfa', {
                                code: code
                            }, {
                                headers: {
                                    Authorization: "Bearer " + this.currentUser.accessToken
                                }
                            })];
                    case 2:
                        result = _a.sent();
                        return [4 /*yield*/, AuthManager.saveRefreshToken(result.data.refreshToken)];
                    case 3:
                        _a.sent();
                        this.currentUser = {
                            phone: this.currentUser.phone,
                            accessToken: result.data.accessToken,
                            tfaMissing: false
                        };
                        this.executeCallbacks();
                        return [3 /*break*/, 5];
                    case 4:
                        e_3 = _a.sent();
                        if (e_3.response && e_3.response.status === 403) {
                            throw new Error('Invalid TFA code');
                        }
                        electron_log_1["default"].error("[Auth] Unable to confirm TFA: " + e_3.message);
                        throw new Error('Unable to access Klink storage');
                    case 5: return [2 /*return*/];
                }
            });
        });
    };
    AuthManager.prototype.logout = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        electron_log_1["default"].info('[Auth] Logging out');
                        this.currentUser = null;
                        return [4 /*yield*/, AuthManager.removeRefreshToken()];
                    case 1:
                        _a.sent();
                        this.executeCallbacks();
                        return [2 /*return*/];
                }
            });
        });
    };
    AuthManager.prototype.getAuthDetails = function () {
        if (this.currentUser === null) {
            return null;
        }
        return AuthManager.generateAuthDetails(this.currentUser);
    };
    AuthManager.prototype.onChange = function (callback) {
        this.callbacks.push(callback);
    };
    AuthManager.saveRefreshToken = function (refreshToken) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                try {
                }
                catch (_b) {
                    // Ignore keystore issues
                }
                return [2 /*return*/];
            });
        });
    };
    AuthManager.removeRefreshToken = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                try {
                }
                catch (_b) {
                    // Ignore keystore issues
                }
                return [2 /*return*/];
            });
        });
    };
    AuthManager.loadRefreshToken = function () {
        return __awaiter(this, void 0, void 0, function () {
            var refreshToken, expirationDate;
            return __generator(this, function (_a) {
                try {
                    refreshToken = localStorage.getItem(APP_SERVICE);
                    if (!refreshToken) {
                        return [2 /*return*/, null];
                    }
                    expirationDate = AuthManager.getJwtExpirationDate(refreshToken);
                    if (expirationDate !== null && expirationDate < new Date()) {
                        return [2 /*return*/, null];
                    }
                    return [2 /*return*/, refreshToken];
                }
                catch (_b) {
                    // Ignore keystore issues
                    return [2 /*return*/, null];
                }
                return [2 /*return*/];
            });
        });
    };
    AuthManager.getJwtExpirationDate = function (jwtToken) {
        var expires = jwt_decode_1["default"](jwtToken).exp;
        if (!expires) {
            return null;
        }
        return new Date(expires * 1000);
    };
    AuthManager.generateAuthDetails = function (user) {
        return {
            phone: user.phone,
            tfaMissing: user.tfaMissing
        };
    };
    AuthManager.prototype.executeCallbacks = function () {
        this.callbacks.forEach(function (callback) { return callback(); });
    };
    return AuthManager;
}());
exports["default"] = AuthManager;
//# sourceMappingURL=auth-manager.js.map