/* eslint react-hooks/exhaustive-deps: 0 */ //--> OFF

import React, { useState, useEffect } from 'react'
import { Contact } from '../../types'
import { ContactAutocompleteByName } from './ContactAutocompleteByName'
import { ContactAutocompleteByPhone } from './ContactAutocompleteByPhone'

type Props = {
  contacts: Contact[]
  value: Contact
  onChange(contact: Contact): void
}

export const ShareWithItem = ({ contacts, value, onChange }: Props) => {
  const [contact, updateContact] = useState(value)

  useEffect(() => {
    onChange(contact)
  }, [contact])

  return (
    <>
      <ContactAutocompleteByName contacts={contacts} contact={contact} updateContact={updateContact} />
      <ContactAutocompleteByPhone contacts={contacts} contact={contact} updateContact={updateContact} />
    </>
  )
}